/******************************************************************************
 * @file  wdog_cdsi.c                                                         *
 *                                                                            *
 *  @author   Ossiel Vazquez Ruiz                         * * * * * * * * * * *
 *     @date   10/09/2019                                 *                   *
 *                                                        *  @version   0.01  *
 *  @brief                                                *                   *
 *    program for Wdog                                    *                   *
 * ************************************************************************** *
 *  @details                                                                  *
 *    $ program developed for EFM32 zero gecko card powerby .. SiliconLabs    *
 *    $ Modules used: GPIO, CMU, INTERRUPT, SYSTICK & WDOG                    *
 * ************************************************************************** *
 *  @warning                             *                                    *
 *    program carried out as a test      *                                    *
 *                                       *   @copyright  Copyright (c) 2019   *
 *  @bug                                 *                                    *
 *    El cielo es el limite              *                                    *
******************************************************************************/

/** INCLUDE HEADER FILE **/
#include "em_device.h"
#include "em_system.h"
#include "em_chip.h"
#include "wdog_cdsi.h"


/** GLOBAL VARIABLES **/
unsigned long rstCause;


/**************************************************************************//**
 * @brief
 *    Watchdog initialization
 *
 * @details
 *    initializes and configures the WDOG
 *
 * @param[in]
 *    NONE
 *
 * @note
 *    Module configuration functions are invoked at the beginning of the main
 *
 * @return 
 *    NULL is always returned
******************************************************************************/
void watchdoginit_cdsi(void)
{
    //Enabling clock to the interface of the low energy modules (including the Watchdog)
    CMU_ClockEnable(cmuClock_HFLE, true);

    //Watchdog Initialize settings
    WDOG_Init_TypeDef wdogInit = WDOG_INIT_DEFAULT;
    wdogInit.debugRun = true;
    wdogInit.em3Run = true;
    wdogInit.clkSel = wdogClkSelULFRCO;
    wdogInit.perSel = wdogPeriod_1k; // 2049 clock cycles of a 1kHz clock  ~2 seconds period

    //Initializing watchdog with chosen settings 
	WDOGn_Init(WDOG, &wdogInit);
  	WDOGn_Enable(WDOG, true);
} /** initWDOG() **/


/**************************************************************************//**
 * @brief
 *    Watchdog get the cause of the reset
 *
 * @details
 *    This function indicates if the reset is due to the wdog
 *
 * @param[in]
 *    NONE
 *
 * @note
 *    Module configuration functions are invoked at the beginning of the main
 *
 * @return 
 *    @ True if a reset was generated by WDOG
 *    @ False if a reset was not generated by WDOG
******************************************************************************/
bool watchdog_getreset_cdsi(void)
{
  	rstCause = RMU_ResetCauseGet();
	
    bool rst_wdg = false;
    // Store the cause of the last reset, and clear the reset cause register 

    // Check if Power on Reset (POR) triggered the last reset 
    if (rstCause & RMU_RSTCAUSE_WDOGRST)
    {
        rst_wdg = true;

#if 0   /* Work in this area if you want to make an event regarding the restart */
        //////////////////////////////////////////////////////////////////////////  
        /* Execute any desired event when the cause of the reset is by the WDOG */
        //////////////////////////////////////////////////////////////////////////
        while(1); //Stay here
#endif
    }  else {
                rst_wdg = false;
            }

    return rst_wdg;
} /** WDG_getRST() **/


/**************************************************************************//**
 * @brief
 *    Watchdog Feed
 *
 * @details
 *    Kick Doggi
 *
 * @param[in]
 *    Nani
 *
 * @note
 *    Module configuration functions are invoked at the main
 *
 * @return 
 *    NULL is always returned
******************************************************************************/
void watchdogfeed_cdsi(void)
{
    WDOGn_Feed(WDOG); //KICK DOG
} /** watchdogfeed_cdsi() **/


/**************************************************************************//**
 * @brief
 *    Watchdog ENABLE
 *
 * @details
 *    Enable/Wisable WATCHDOG
 *
 * @param[in]
 *    Nani
 *
 * @note
 *    Module configuration functions are invoked at the main
 *
 * @return 
 *    NULL is always returned
******************************************************************************/
void watchdogenable_cdsi(bool state)
{
    WDOGn_Enable(WDOG, state);
} /** watchdogenable_cdsi() **/


/** END OF FILE **/